﻿using System;

namespace AdminPanelNS
{
    public partial class Login : System.Web.UI.Page
    {
        protected string _contentClass;

        protected void Page_Load(object sender, EventArgs e)
        {
            _contentClass = "wm_content_server";
            if (Utils.IsPluginExist("WebMailLite"))
            {
                _contentClass = Utils.IsPluginExist("Server") ? "wm_content_serverlite" : "wm_content_webmaillite";
            }
            if (Utils.IsPluginExist("WebMail"))
            {
                _contentClass = Utils.IsPluginExist("Server") ? "wm_content_server" : "wm_content_webmail";
            }
        }

        protected void Enter_OnClick(object sender, EventArgs e)
        {
            try
            {
                AdminPanelSettings apSettings = new AdminPanelSettings();
                apSettings.LoadAdminPanelSettings();

                if ((apSettings.User != LoginID.Value) || (apSettings.Pass != PasswordID.Value))
                {
                    Utils.SetPageErrorMessage(Page, "Wrong login and/or password. Authentication failed.");
                }
                else
                {
                    Utils.SaveState("AUTH", true, Page.Session);
                    Response.Redirect("AdminPanel.aspx");
                }
            }
            catch (Exception ex)
            {
                Utils.SetPageErrorMessage(Page, ex.Message);
            }
            return;
        }
    }
}