using System.Globalization;
using System;

public partial class webmailLite_settings : System.Web.UI.UserControl
{
	protected void Page_Load(object sender, System.EventArgs e)
	{
        WebMailLite.WebmailSettings settings = new WebMailLite.WebmailSettings().CreateInstance(Utils.GetWebMailDataFolder());


		if (!Page.IsPostBack)
		{
			txtSiteName.Value = settings.SiteName;

			txtIncomingMail.Value = settings.IncomingMailServer;
			intIncomingMailPort.Value = settings.IncomingMailPort.ToString(CultureInfo.InvariantCulture);

            if (settings.IncomingMailProtocol == WebMailLite.IncomingMailProtocol.Pop3)
			{
				intIncomingMailProtocol.SelectedIndex = 0;
			}
            else if (settings.IncomingMailProtocol == WebMailLite.IncomingMailProtocol.Imap4)
			{
				intIncomingMailProtocol.SelectedIndex = 1;
			}
            else if (settings.IncomingMailProtocol == WebMailLite.IncomingMailProtocol.WMServer)
			{
				intIncomingMailProtocol.SelectedIndex = 2;
			}

			txtOutgoingMail.Value = settings.OutgoingMailServer;
			intOutgoingMailPort.Value = settings.OutgoingMailPort.ToString(CultureInfo.InvariantCulture);

			intReqSmtpAuthentication.Checked = settings.ReqSmtpAuth;

            intAttachmentSizeLimit.Value = Math.Round((double) (settings.AttachmentSizeLimit / 1024)).ToString(CultureInfo.InvariantCulture);
			intEnableAttachmentSizeLimit.Checked = settings.EnableAttachmentSizeLimit;
            intMailboxSizeLimit.Value = Math.Round((double)(settings.MailboxSizeLimit / 1024)).ToString(CultureInfo.InvariantCulture);
			intEnableMailboxSizeLimit.Checked = settings.EnableMailboxSizeLimit;

			txtDefaultUserCharset.Value = settings.DefaultUserCharset.ToString();

			if (settings.DefaultTimeZone < txtDefaultTimeZone.Items.Count)
			{
				txtDefaultTimeZone.SelectedIndex = settings.DefaultTimeZone;
			}
		}

		string javascript = @"
<script type=""text/javascript"">
	function mailProtocolChange() 
	{
		// change port
		var select = document.getElementById('" + intIncomingMailProtocol.ClientID + @"');
		var port = document.getElementById('" + intIncomingMailPort.ClientID + @"');
		port.value = (select.value == 'POP3') ? '110' : '143';
	}
	
    function Run()
	{
		if (document.getElementById('" + intEnableAttachmentSizeLimit.ClientID + @"').checked)
		{
			document.getElementById('" + intAttachmentSizeLimit.ClientID + @"').readOnly = false;
			document.getElementById('" + intAttachmentSizeLimit.ClientID + @"').style.background = ""#FFFFFF"";
		}
		else
		{
			document.getElementById('" + intAttachmentSizeLimit.ClientID + @"').readOnly = true;
			document.getElementById('" + intAttachmentSizeLimit.ClientID + @"').style.background = ""#EEEEEE"";
		}
		
		if (document.getElementById('" + intEnableMailboxSizeLimit.ClientID + @"').checked)
		{
			document.getElementById('" + intMailboxSizeLimit.ClientID + @"').readOnly = false;
			document.getElementById('" + intMailboxSizeLimit.ClientID + @"').style.background = ""#FFFFFF"";
		}
		else
		{
			document.getElementById('" + intMailboxSizeLimit.ClientID + @"').readOnly = true;
			document.getElementById('" + intMailboxSizeLimit.ClientID + @"').style.background = ""#EEEEEE"";
		}
	}
</script>
";
		string javascriptStartup = @"
<script type=""text/javascript"">
	Run();
</script>
";
		if (!Page.ClientScript.IsClientScriptBlockRegistered(this.GetType(), "CommonSettingsClientScript"))
		{
			Page.ClientScript.RegisterClientScriptBlock(this.GetType(), "CommonSettingsClientScript", javascript, false);
		}
		if (!Page.ClientScript.IsStartupScriptRegistered(this.GetType(), "CommonSettingsStartupClientScript"))
		{
			Page.ClientScript.RegisterStartupScript(this.GetType(), "CommonSettingsStartupClientScript", javascriptStartup, false);
		}

	}

	#region Web Form Designer generated code
	override protected void OnInit(EventArgs e)
	{
		//
		// CODEGEN: This call is required by the ASP.NET Web Form Designer.
		//
		InitializeComponent();
		base.OnInit(e);
	}

	/// <summary>
	///		Required method for Designer support - do not modify
	///		the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{

	}
	#endregion

	protected void SaveButton_Click(object sender, System.EventArgs e)
	{
		try
		{
            WebMailLite.WebmailSettings settings = new WebMailLite.WebmailSettings().CreateInstance(Utils.GetWebMailDataFolder());
			
            settings.SiteName = txtSiteName.Value;
			settings.IncomingMailServer = txtIncomingMail.Value;
			try
			{
				settings.IncomingMailPort = int.Parse(intIncomingMailPort.Value, CultureInfo.InvariantCulture);
			}
			catch(Exception ex) 
            {
                Utils.SetPageReportMessage(this.Page, ex.Message);
            }

			switch (intIncomingMailProtocol.Value.ToLower(CultureInfo.InvariantCulture))
			{
				case "pop3":
                    settings.IncomingMailProtocol = WebMailLite.IncomingMailProtocol.Pop3;
					break;
				case "imap4":
                    settings.IncomingMailProtocol = WebMailLite.IncomingMailProtocol.Imap4;
					break;
				case "xmail":
                    settings.IncomingMailProtocol = WebMailLite.IncomingMailProtocol.WMServer;
					break;
			}

			settings.OutgoingMailServer = txtOutgoingMail.Value;
			try
			{
				settings.OutgoingMailPort = int.Parse(intOutgoingMailPort.Value, CultureInfo.InvariantCulture);
			}
            catch (Exception ex)
            {
                Utils.SetPageReportMessage(this.Page, ex.Message);
            }

			settings.ReqSmtpAuth = intReqSmtpAuthentication.Checked;

			try
			{
				settings.AttachmentSizeLimit = long.Parse(intAttachmentSizeLimit.Value, CultureInfo.InvariantCulture) * 1024;
			}
            catch (Exception ex)
            {
                Utils.SetPageReportMessage(this.Page, ex.Message);
            }
            settings.EnableAttachmentSizeLimit = intEnableAttachmentSizeLimit.Checked;
			try
			{
				settings.MailboxSizeLimit = long.Parse(intMailboxSizeLimit.Value, CultureInfo.InvariantCulture) * 1024;
			}
            catch (Exception ex)
            {
                Utils.SetPageReportMessage(this.Page, ex.Message);
            }
            settings.EnableMailboxSizeLimit = intEnableMailboxSizeLimit.Checked;

			try
			{
				settings.DefaultUserCharset = int.Parse(txtDefaultUserCharset.Value, CultureInfo.InvariantCulture);
			}
            catch (Exception ex)
            {
                Utils.SetPageReportMessage(this.Page, ex.Message);
            }
			settings.DefaultTimeZone = (short)txtDefaultTimeZone.SelectedIndex;

			settings.SaveWebmailSettings(Utils.GetWebMailDataFolder());

            Utils.SetPageReportMessage(this.Page, WebMailLite.Constants.mailAdmSaveSuccess);
		}
		catch (Exception)
		{
            Utils.SetPageErrorMessage(this.Page, WebMailLite.Constants.mailAdmSaveUnsuccess);
		}
	}
}
