using MailBee.Mime;

namespace WebMailLite.classic
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		Summary description for Toolbar.
	/// </summary>
	public class Toolbar : System.Web.UI.UserControl
	{
		protected jsbuilder _js;
		public jsbuilder js
		{
			get { return _js; }
			set
			{
				Log.WriteLine(@"JS Property", "Set Toolbar JS");
				_js = value;
			}
		}

		protected Account _acct = null;
		public Account CurrentAccount
		{
			get { return _acct; }
			set { _acct = value; }
		}

		protected string _skin = Constants.defaultSkinName;
		protected WebmailResourceManager _manager = null;
		protected string screen = null;
		protected long _id_folder;

		protected bool IsSearch = false;
		protected string LookFor = "";

		protected System.Web.UI.WebControls.PlaceHolder BackToList;
		protected System.Web.UI.WebControls.PlaceHolder NewMessage;
		protected System.Web.UI.WebControls.PlaceHolder Refresh;
		protected System.Web.UI.WebControls.PlaceHolder Reply;
		protected System.Web.UI.WebControls.PlaceHolder Forward;
		protected System.Web.UI.WebControls.PlaceHolder DeletePop;
		protected System.Web.UI.WebControls.PlaceHolder Save;
		protected System.Web.UI.WebControls.PlaceHolder Send;
		protected System.Web.UI.WebControls.PlaceHolder Print;
		protected System.Web.UI.WebControls.PlaceHolder Importance;
		protected System.Web.UI.WebControls.PlaceHolder PreviousMsg;
		protected System.Web.UI.WebControls.PlaceHolder NextMsg;
		protected string strpadding = String.Empty;
		protected bool IsTrash = false;
		protected string MessageDownloadLink = "";
		protected MailMessage msg = null;
		protected string uid;
		protected int charset;

		public string Skin
		{
			get { return _skin; }
			set { _skin = value; }
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			_manager = (new WebmailResourceManagerCreator()).CreateResourceManager();

			_acct = Session[Constants.sessionAccount] as Account;

			LoadButtons();
		}

		public void LoadButtons()
		{
			try
			{
				LoadData();

				BaseWebMailActions bwa = new BaseWebMailActions(_acct, this.Page);

				if(Request.QueryString.Get("scr") == null)
				{
					screen = null;
				}
				else
				{
					screen = Request.QueryString.Get("scr").ToLower();
				}

				HideButtons();

				switch(screen)
				{
					case "view_message":
						BackToList.Visible = true;
						NewMessage.Visible = true;
						Reply.Visible= true;
						Forward.Visible = true;
						Save.Visible = true;
						Print.Visible = true;
						DeletePop.Visible = true;
						AddJavaScriptViewMessage();
						break;
					case "new_message":
					case "reply_message":
					case "replyall_message":
					case "forward_message":
						BackToList.Visible = true;
						Send.Visible = true;
						Importance.Visible = true;
						AddJavaScriptNewMessage();
						break;
					default:
						NewMessage.Visible = true;
						Refresh.Visible = true;
						DeletePop.Visible = true;
						AddJavaScriptDefault();
						break;
				}
			}
			catch (Exception ex)
			{
				((basewebmail)this.Page).OutputException(ex);
			}
		}

		protected void LoadData()
		{
			_id_folder = (Session["id_folder"] != null) ? (long)Session["id_folder"] : -1;
			//Current Search
			if(Session["is_search"] != null)
			{
				IsSearch = (bool)Session["is_search"];
				LookFor = (string)Session["look_for"];
			}
			else
			{
				IsSearch = false;
				LookFor = null;
			}
		}

		protected void AddJavaScriptViewMessage()
		{
			if(Session["uid"] != null)
			{
				BaseWebMailActions bwml = new BaseWebMailActions(_acct, this.Page);
				uid = (string)Session["uid"];
				/*charset = (int)Session["charset"];
				msg = bwml.GetMessage(uid, charset, 1);*/
                MessageDownloadLink = Utils.GetMessageDownloadLink(uid);

				_js.AddText(@"
					function DoSaveButton()
					{
						document.location = '" + MessageDownloadLink + @"';
					}
					function DoPrintButton()
					{
						var allHeight = GetHeight();
						var allWidth = GetWidth();
						var height = 480; if (height >= allHeight) height = Math.ceil(allHeight*2/3);
						var width = 640; if (width >= allWidth) width = Math.ceil(allWidth*2/3);
						var top = Math.ceil((allHeight - height)/2)
						var left = Math.ceil((allWidth - width)/2)
						var win = window.open('msgprint.aspx', 'Popup', 'toolbar=yes,status=no,scrollbars=yes,resizable=yes,width=' + width + ',height=' + height + ',top=' + top + ',left=' + left);
					}
				");
			}
		}

		protected void AddJavaScriptDefault()
		{
			string text = String.Empty;

			text = @"
				function DoDeleteMessages()
				{
					var idsArray = InboxLines.GetCheckedLines();
					
					if(idsArray.IdArray.length > 0 && confirm('" + _manager.GetString("ConfirmAreYouSure") + @"'))
					{
						HFAction = document.getElementById('HFAction');
						HFRequest = document.getElementById('HFRequest');
						HFValue = document.getElementById('HFValue');
						
						HFAction.value = 'operation_messages';
						HFRequest.value = 'delete';
						var value = '';

						for(i = 0; idsArray.IdArray.length > i; i++)
						{
							if(idsArray.IdArray.length != i+1)
							{
								value += idsArray.IdArray[i] + ""@#%"";
							}
							else
							{
								value += idsArray.IdArray[i];
							}
						}
						HFValue.value = value;
						
						__doPostBack('PostBackButton','');
					}
					else
					{
						alert(""" + _manager.GetString("WarningMarkListItem") + @""");
					}
				}
			";

			Log.WriteLine(@"JS Property", "JS ADD TEXT");
			_js.AddText(text);

		}

		protected void AddJavaScriptNewMessage()
		{
			_js.AddInitText(@"
	PriorityImg = document.getElementById('priority_img');
	PriorityText = document.getElementById('priority_text');
	PriorityInput = document.getElementById('priority_input');
");

			_js.AddText(@"

	var PriorityImg, PriorityText, PriorityInput;

	function SetPriority(value)
	{
		switch (value) {
			case 5:
				PriorityInput.value = 5;
				PriorityImg.src = 'skins/" + _skin + @"/menu/priority_low.gif';
				PriorityText.innerHTML = '" + _manager.GetString("Low") + @"';
			break;
			default:
			case 3:
				PriorityInput.value = 3;
				PriorityImg.src = 'skins/" + _skin + @"/menu/priority_normal.gif';
				PriorityText.innerHTML = '" + _manager.GetString("Normal") + @"';
			break;
			case 1:
				PriorityInput.value = 1;
				PriorityImg.src = 'skins/" + _skin + @"/menu/priority_high.gif';
				PriorityText.innerHTML = '" + _manager.GetString("High") + @"';
			break;
		}
	}

	function ChangePriority()
	{
		switch (PriorityInput.value) {
			case '5':
				SetPriority(3);
			break;
			default:
			case '3':
				SetPriority(1);
			break;
			case '1':
				SetPriority(5);
			break;
		}
	}

	function DoSendButton()
	{
		var fromValue = Trim(document.getElementById('newMessageID_fromTextBox').value);
		if (fromValue.length < 1)
		{
			alert(Lang.WarningFromBlank);
			return;
		}

		var toValue = Trim(document.getElementById('newMessageID_toTextBox').value);
		var ccValue = Trim(document.getElementById('newMessageID_ccTextBox').value);
		var bccValue = Trim(document.getElementById('newMessageID_bccTextBox').value);
		if (toValue.length < 1 && ccValue.length < 1 && bccValue.length < 1)
		{
			alert(Lang.WarningToBlank);
			return;
		}
		var subjectValue = document.getElementById('newMessageID_subjectTextBox').value;
		if (subjectValue.length != 0 || confirm(Lang.ConfirmEmptySubject))
		{
			if (bccMode == 'hide')
			{
				document.getElementById('newMessageID_bccTextBox').value = '';
			}
			var HFAction = document.getElementById('HFAction');
			var HFRequest = document.getElementById('HFRequest');
			HFAction.value = 'send';
			HFRequest.value = 'message';

			__doPostBack('PostBackButton','');
		}
	}
			");
		}

		protected void HideButtons()
		{
			BackToList.Visible = false;
			NewMessage.Visible = false;
			Refresh.Visible = false;
			Reply.Visible = false;
			Forward.Visible = false;
			DeletePop.Visible = false;
			Save.Visible = false;
			Send.Visible = false;
			Print.Visible = false;
			Importance.Visible = false;
			PreviousMsg.Visible = false;
			NextMsg.Visible = false;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
