using System;
using System.Web;
using System.Web.UI.WebControls;
using System.Globalization;
using MailBee.Mime;

namespace WebMailLite.classic
{
	/// <summary>
	///		Summary description for ViewMessage.
	/// </summary>
	public class ViewMessage : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.Label LabelFrom;
		protected System.Web.UI.WebControls.Label LabelTo;
		protected System.Web.UI.WebControls.Label LabelDate;
		protected System.Web.UI.WebControls.Label LabelSubject;
		protected System.Web.UI.HtmlControls.HtmlTableRow CharsetList;
		protected System.Web.UI.WebControls.LinkButton LinkButtonSwitchTo;
		protected System.Web.UI.WebControls.DropDownList DropDownListCharsets;
		protected System.Web.UI.HtmlControls.HtmlContainerControl headersDiv;
		protected System.Web.UI.WebControls.Literal FillMessage;
		protected System.Web.UI.WebControls.Literal LiteralAttachments;
        protected System.Web.UI.WebControls.Literal LabelPriority;

        protected string _uid = null;
		protected int _charset = 0;
		protected jsbuilder _js;
		protected string _skin;
		protected Account acct;
		protected WebmailResourceManager _manager = null;
		protected MailMessage msg = null;
		protected MailBee.Mime.AttachmentCollection Attachment = null;
		protected bool LoadHTMLMessage = true;

		protected bool IsHTMLMsg = false;
		protected string msgPlain = null;
		protected string msgHTML = null;
		protected string HTMLAttachments = null;
		protected string HTMLViewLink = null;
		protected string DownloadLink = null;
		protected string IconLink = null;
		protected string ViewLink = null;

		public string uid
		{
			get { return _uid; }
			set { _uid = value; }
		}

		public int charset
		{
			get { return _charset; }
			set { _charset = value; }
		}
		
		public jsbuilder js
		{
			get { return _js; }
			set { _js = value; }
		}

		public string Skin
		{
			get { return _skin; }
			set { _skin = value; }
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			acct = Session[Constants.sessionAccount] as Account;

			if (acct == null)
			{
				Response.Redirect("default.aspx");
			}
			else
			{
				_manager = (new WebmailResourceManagerCreator()).CreateResourceManager();

				string text = @"
					function ResizeElements(mode) 
					{
						NewResizeElements(mode);
						if (!Browser.IE) NewResizeElements(mode);
					}

					function NewResizeElements(mode)
					{
						var height = GetHeight();
						var width = GetWidth();
						var exx = 0; 
						var offsetHeight = 0;
						offsetHeight = (logo) ? logo.offsetHeight : 0;
						exx += (offsetHeight) ? offsetHeight : 0;
						offsetHeight = (accountlist) ? accountlist.offsetHeight : 0;
						exx += (offsetHeight) ? offsetHeight : 0;
						offsetHeight = (toolbar) ? toolbar.offsetHeight : 0;
						exx += (offsetHeight) ? offsetHeight : 0;
						mainContainer.style.height = (height - exx) + 'px';      
						mainContainer.style.width = width + 'px';
						m_message.style.width = (width - 20) + 'px';

						if (resizerObj) var atWidth = resizerObj._leftShear;
						else var atWidth = '0';

var maxAttachWidth = width - 42;
if (atWidth > maxAttachWidth) atWidth = maxAttachWidth;

m_attachments.style.height = resDiv.style.height = m_message.style.height = (height - exx - m_headers.offsetHeight - m_lowtoolbar.offsetHeight - 4) + 'px';
m_message_body.style.height = (height - exx - m_headers.offsetHeight - m_lowtoolbar.offsetHeight - 16 - 4) + 'px';

m_attachments.style.width = atWidth + 'px';
m_attachments.style.left = '0px';

if (messageWithAttach)
{
	m_message_body.style.width = (mainContainer.offsetWidth - m_attachments.offsetWidth - resDiv.offsetWidth - 16 - 15) + 'px';
	m_message_body.style.left = (atWidth + 2) + 'px';
	if (resizerObj) 
	{
		resDiv.style.width = '2px';
		resDiv.style.left = atWidth + 'px';
	}
}
else
{
	m_message_body.style.width = (mainContainer.offsetWidth - 16 - 15) + 'px';
	m_message_body.style.left = '0px';
}
					}

					function ShowHideHeaders()
					{
						var objDiv = document.getElementById(""headersCont"");
						var objSpan = document.getElementById(""ShowHideText"");
						var Show = """ + _manager.GetString("ShowFullHeaders") + @"""
						var Hide = """ + _manager.GetString("HideFullHeaders") + @"""

						if(objDiv.className == ""wm_hide"")
						{
							objSpan.innerHTML = Hide;
							objDiv.className = ""wm_headers"";
						}
						else
						{
							objSpan.innerHTML = Show;
							objDiv.className = ""wm_hide"";
						}
					}

					function DoReplyButton()
					{
						HFAction = document.getElementById(""HFAction"");
						
						HFAction.value = """";
						
						HFAction.value = ""reply"";
						
						__doPostBack('PostBackButton','');
					}

					function DoReplyAllButton()
					{
						HFAction = document.getElementById(""HFAction"");
						
						HFAction.value = """";
						
						HFAction.value = ""replyall"";
						
						__doPostBack('PostBackButton','');
					}

					function DoForwardButton()
					{
						HFAction = document.getElementById(""HFAction"");
						
						HFAction.value = """";
						
						HFAction.value = ""forward"";
						
						__doPostBack('PostBackButton','');
					}

				function ChangeCharset()
				{
					HFValue = document.getElementById(""HFValue"");
					DDLCharsets = document.getElementById(""newViewMessage_DropDownListCharsets"");
					
					var tempArr = HFValue.value.split(""----"");

					HFValue.value = tempArr[0] + ""----"" + DDLCharsets.value;
					
					__doPostBack('PostBackButton','');
				}

				function DoDeleteMessages()
				{
					if (confirm('" + _manager.GetString("ConfirmAreYouSure") + @"'))
					{
						HFAction = document.getElementById('HFAction');
						HFRequest = document.getElementById('HFRequest');
						HFValue = document.getElementById('HFValue');
						
						HFAction.value = 'delete';
						HFRequest.value = 'message';

						__doPostBack('PostBackButton','');
					}
				}

function CFullHeadersViewer()
{
	this._headersCont = document.getElementById('headersCont');
	this._headersDiv = document.getElementById('newViewMessage_headersDiv');
	this._control = document.getElementById('fullheadersControl');
	this._isShow = false;
}

CFullHeadersViewer.prototype = 
{
	Show: function()
	{
		if (!this._isShow)
		{
			var height = GetHeight();
            var width = GetWidth();
            
			var win_height = height*3/5;
			var win_width = width*3/5;		
			
			this._control.innerHTML = Lang.HideFullHeaders;
			this._headersCont.className = 'wm_headers';

			this._headersCont.style.width = win_width + 'px';
			this._headersCont.style.height = win_height + 'px';
			this._headersCont.style.top = (height - win_height)/2 + 'px';
			this._headersCont.style.left = (width - win_width)/2 + 'px';
			this._headersDiv.style.width = win_width - 10 + 'px';
			this._headersDiv.style.height = win_height - 30 + 'px';		
		
			var obj = this;
			this._control.onclick = function()
			{
				obj.Hide();
			}
			this._isShow = true;
		}
		return false;
	},
	
	Hide: function()
	{
		this._isShow = false;
		var obj = this;
		this._control.onclick = function()
		{
			obj.Show();
		}
		this._headersCont.className = 'wm_hide';
		this._control.innerHTML = Lang.ShowFullHeaders;
		return false;
	}
}
				";

				_js.AddText(text);

				_js.AddFile("classic/class_maillist.js");

				_js.AddText("var logo, accountlist, toolbar, FullHeaders, mainContainer, resizerObj;");
				_js.AddText("var m_headers, m_attachments, m_message_body, m_lowtoolbar, m_message, resDiv, divBody;");

				_js.AddText("function InitBody() {}");
				_js.AddInitText(@"divBody = document.getElementById(""message_body"");");

				text = @"
					PopupMenu.addItem(document.getElementById('popup_menu_4'), document.getElementById('popup_control_4'), 'wm_popup_menu', document.getElementById('popup_replace_4'), document.getElementById('popup_title_4'), 'wm_tb', 'wm_tb_press', 'wm_toolbar_item', 'wm_toolbar_item_over');
					logo = document.getElementById(""logo"");
					accountlist = document.getElementById(""accountslist"");
					toolbar = document.getElementById(""toolbar"");
					FullHeaders = new CFullHeadersViewer();
					mainContainer = document.getElementById(""wm_mail_container"");
					m_headers = document.getElementById(""message_headers"");
					m_attachments = document.getElementById(""attachments"");
					m_message_body = document.getElementById(""message_body"");
					m_lowtoolbar = document.getElementById(""lowtoolbar"");
					m_message = document.getElementById(""message"");	
					resDiv = document.getElementById(""resizerDiv"");

					if (messageWithAttach)
					{
						resizerObj = new CVerticalResizer(resDiv, m_message, 2, 10, 40, 140, ""ResizeElements('all');"", 1);
					}
					else
					{
						m_attachments.className = 'wm_hide';
						resDiv.className = 'wm_hide';
					}

					InitBody();
				";

				_js.AddInitText(text);

				Load_Message(acct);

				LoadData();
			}
		}

		protected void LoadData()
		{
			if ((object)ViewState["LoadHTMLMessage"] == null)
			{
				ViewState["LoadHTMLMessage"] = true;
			}

			LoadHTMLMessage = (bool)ViewState["LoadHTMLMessage"];
		}

		protected void SaveData()
		{
			ViewState["LoadHTMLMessage"] = LoadHTMLMessage;
		}

		protected void WriteBodyTextByJs(string BodyText)
		{
			FillMessage.Text = @"<script>function InitBody() { if (divBody) divBody.innerHTML = """ + Utils.EncodeJsSaveString(BodyText) + @"""; }</script>";
		}

		public void Load_Message(Account acct)
		{
            _js.AddText("var messageWithAttach = false;");
            try
			{
				//Reser values
				IsHTMLMsg = false;
				msgPlain = null;
				msgHTML = null;

				//Load Message
				BaseWebMailActions bwml = new BaseWebMailActions(acct, this.Page);

				msg = bwml.GetMessage(_uid, _charset);

				msgPlain = msg.BodyPlainText;
				msgHTML = msg.BodyHtmlText;

                if (msgPlain.Trim() == "")
                {
                    msgPlain = Utils.ConvertHtmlToPlain(msgHTML);
                }
                msgPlain = Utils.MakeHtmlBodyFromPlainBody(msgPlain);

                if (msgHTML.Trim() != "")
                {
					LinkButtonSwitchTo.Visible = true;
					LinkButtonSwitchTo.Text = _manager.GetString("SwitchToPlain");

					//Message body
					WriteBodyTextByJs(msgHTML);
				}
				else
				{
					LinkButtonSwitchTo.Visible = true;

					IsHTMLMsg = false;

					//Message body
					WriteBodyTextByJs(msgPlain);
				}

				//Message headers
				LabelFrom.Text = Server.HtmlEncode(msg.From.ToString());
				LabelTo.Text = Server.HtmlEncode(msg.To.ToString());
				LabelDate.Text = Utils.GetDateWithOffsetFormatString(acct, msg.DateReceived.ToUniversalTime());
				LabelSubject.Text = Server.HtmlEncode(msg.Subject);

                LabelPriority.Text = (msg.Priority == MailPriority.High || msg.Priority == MailPriority.Highest)
                    ? @"<img class='wm_importance_img'  src='skins/" + Skin + "/menu/priority_high.gif'>" : "";

				if(msg.Charset.Length > 0)
				{
					CharsetList.Visible = false;
				}
				else
				{
					CharsetList.Visible = true;
	
					DropDownListCharsets.Items.Clear();

					for(int i = 0; Constants.Charsets.Length > i; i++)
					{
						ListItem CharsetsItem = new ListItem();

						CharsetsItem.Text = _manager.GetString(Constants.Charsets[i]);
						CharsetsItem.Value = Constants.PageNumber[i].ToString();

						DropDownListCharsets.Items.Add(CharsetsItem);
					}
                    //TODO: override charset!!!
					DropDownListCharsets.SelectedValue = Utils.GetCodePageNumber(msg.Charset).ToString();
				}

				headersDiv.InnerHtml = @"<pre>" + Utils.EncodeHtml(msg.RawHeader) + @"</pre>";

				if(msg.HasAttachments)
				{

					_js.AddText("messageWithAttach = true;");
					HTMLAttachments = "";

					Attachment = msg.Attachments;

					for(int i = 0; Attachment.Count > i; i++)
					{
						HTMLViewLink = "";

						DownloadLink = Utils.GetAttachmentDownloadLink(Attachment[i], false);
						IconLink = Utils.GetAttachmentIconLink(Attachment[i]);

						switch(Attachment[i].ContentType.ToLower(CultureInfo.InvariantCulture))
						{
							case "image/bmp":
							case "image/gif":
							case "image/jpg":
							case "image/jpeg":
							case "image/tif":
							case "image/tiff":
								ViewLink = Utils.GetAttachmentDownloadLink(Attachment[i], true);
								HTMLViewLink = @"<br/><a class=""wm_attach_view_a"" href=""javascript:void(0)"" onclick=""javascript:PrevImg('" + ViewLink + @"')"">" + _manager.GetString("View") + @"</a>";
								break;
						}

						HTMLAttachments += @"
						<div class=""wm_message_attachments"" id=""attachments"">
							<div style=""float: left;"">
								<a class=""wm_attach_download_a"" href=""" + DownloadLink + @""">
									<img title=""" + _manager.GetString("ClickToDownload") + @" " + Attachment[i].Filename + @" (" + Utils.GetFriendlySize(Attachment[i].Size) + @")"" src=""" + IconLink + @""" />
									<br/>
									<span title=""" + _manager.GetString("ClickToDownload") + @" " + Attachment[i].Filename + @" (" + Utils.GetFriendlySize(Attachment[i].Size) + @")"">" + Utils.GetShortFilename(Attachment[i].Filename) + @"</span>
								</a>"
							+ HTMLViewLink
							+ @"</div>
						</div>
					";

					}

					LiteralAttachments.Text = HTMLAttachments;
				}
				else
				{
					_js.AddText("messageWithAttach = false;");
					LiteralAttachments.Text = "";
				}
			}
			catch (Exception ex)
			{
				((basewebmail)this.Page).OutputException(ex);
			}
		}

		private void LinkButtonSwitchTo_Click(object sender, EventArgs e)
		{
			if(LoadHTMLMessage)
			{
				WriteBodyTextByJs(msgPlain);
				LinkButtonSwitchTo.Text = _manager.GetString("SwitchToHTML");

				LoadHTMLMessage = false;
			}
			else
			{
				WriteBodyTextByJs(msgHTML);
				LinkButtonSwitchTo.Text = _manager.GetString("SwitchToPlain");

				LoadHTMLMessage = true;
			}
			
			SaveData();
		}

		public void ChangeCharset(object sender, System.EventArgs e)
		{
			_charset = Convert.ToInt32(DropDownListCharsets.SelectedValue);
			Load_Message(acct);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);
			LinkButtonSwitchTo.Click +=new EventHandler(LinkButtonSwitchTo_Click);
		}
		#endregion
	}
}