using System;
using System.Collections;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using MailBee.Mime;

namespace WebMailLite
{
	/// <summary>
	/// Summary description for _default.
	/// </summary>
	public class _default : System.Web.UI.Page
	{
		protected WebmailResourceManager _resMan = null;

		protected const int POP3_PROTOCOL = 0;
		protected const int IMAP4_PROTOCOL = 1;
		protected const int WMSERVER_PROTOCOL = 2;

		protected string defaultTitle = string.Empty;
		protected string defaultSkin = string.Empty;
		protected string defaultIncServer = string.Empty;
		protected int defaultIncProtocol = POP3_PROTOCOL;
		protected int defaultIncPort = 110;
		protected string defaultOutServer = string.Empty;
		protected int defaultOutPort = 25;
		protected bool defaultUseSmtpAuth = true;
		protected bool defaultSignMe = false;
		protected string defaultIsAjax = "true";
		/*****************************/
		protected string defaultAllowAdvancedLogin = "true";
		protected int defaultHideLoginMode = 1;
		protected string defaultDomainOptional = "localhost";
		/*****************************/
		protected string errorClass = string.Empty;
		protected string errorDesc = string.Empty;
		protected string mode = string.Empty;
		protected string switcherHref = string.Empty;
		protected string switcherText = string.Empty;

		protected string emailClass = string.Empty;
		protected string loginClass = string.Empty;
		protected string advancedDisplay = string.Empty;
		protected string loginWidth = "99%";
		protected string domainContent = string.Empty;
	
		protected string advancedLogin = string.Empty;
		protected string pop3Selected = string.Empty;
		protected string imap4Selected = string.Empty;
		protected string wmserverSelected = string.Empty;
		protected string smtpAuthChecked = string.Empty;
		protected string signMeChecked = string.Empty;
		protected string globalEmail = string.Empty;
		protected string globalLogin = string.Empty;
		protected string globalPassword = string.Empty;
		protected string globalIncServer = string.Empty;
		protected string globalIncProtocol = string.Empty;
		protected string globalIncPort = string.Empty;
		protected string globalOutServer = string.Empty;
		protected string globalOutPort = string.Empty;
		protected string globalUseSmtpAuth = string.Empty;
		protected string globalSignMe = string.Empty;
		protected string globalAdvancedLogin = string.Empty;

		protected string WmServerToHTML = string.Empty;

		protected WebmailSettings settings = null;

		public _default()
		{
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				this.Context.Application.Remove(Constants.sessionSettings);
				string mode = Request["mode"];
				if (mode == "logout")
				{
					FileSystem.DeleteAccountTempFolder(Utils.GetTempFolderName(Session));
					Session.Clear();
				}
				if (Application[Constants.appSettingsDataFolderPath] == null)
				{
					Application[Constants.appSettingsDataFolderPath] = ConfigurationManager.AppSettings[Constants.appSettingsDataFolderPath];
				}
			}
			try
			{
				_resMan = (new WebmailResourceManagerCreator()).CreateResourceManager();
				settings = (new WebMailSettingsCreator()).CreateWebMailSettings();
			}
			catch (WebMailSettingsException)
			{

				System.IO.StreamReader rdr=new System.IO.StreamReader(Request.MapPath("~")+"\\Copyright.ascx");
				string content=rdr.ReadToEnd();
				int idx=content.IndexOf("%>")+4;
				content=content.Substring(idx,content.Length-idx);

				Response.Write(@"<!DOCTYPE html PUBLIC ""-//W3C//DTD XHTML 1.0 Transitional//EN"" ""http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"" />
<html>
<head>
    <meta http-equiv=""Content-Type"" content=""text/html; charset=utf-8"" />
    <meta http-equiv=""Content-Script-Type"" content=""text/javascript"" />
    <meta http-equiv=""Cache-Control"" content=""private,max-age=1209600"" />
    <title>WebMail probably not configured</title>
    <link rel=""stylesheet"" href=""skins/Hotmail_Style/styles.css"" type=""text/css"" />
</head>
<body>
<div align=""center"" id=""content"" class=""wm_content"">
    <div class=""wm_logo"" id=""logo"" tabindex=""-1""></div>
    <div class=""wm_login_error"">WebMail probably not configured</div>"+content+"</div></body></html>");

				Response.End();
				return;
			}

			try
			{

				defaultTitle = Utils.EncodeJsSaveString(settings.SiteName);
				defaultSkin = Utils.EncodeJsSaveString(settings.DefaultSkin);
				defaultIncServer = settings.IncomingMailServer;
											   
				switch(settings.IncomingMailProtocol)
				{
					case IncomingMailProtocol.Pop3:
					{
						defaultIncProtocol = POP3_PROTOCOL;
						break;
					}

					case IncomingMailProtocol.Imap4:
					{
						defaultIncProtocol = IMAP4_PROTOCOL;
						break;
					}

					case IncomingMailProtocol.WMServer:
					{
						defaultIncProtocol = WMSERVER_PROTOCOL;
						break;
					}
				}

				defaultIncPort = settings.IncomingMailPort;
				defaultOutServer = settings.OutgoingMailServer;
				defaultOutPort = settings.OutgoingMailPort;
				defaultUseSmtpAuth = settings.ReqSmtpAuth;
				defaultSignMe = false;
				defaultIsAjax = settings.AllowAjax ? "true" : "false";
				defaultAllowAdvancedLogin = (settings.AllowAdvancedLogin) ? "true" : "false";
				defaultHideLoginMode = (int)settings.HideLoginMode;
				defaultDomainOptional = Utils.EncodeJsSaveString(settings.DefaultDomainOptional);

				if (defaultIncProtocol == POP3_PROTOCOL)
				{
					pop3Selected = @" selected=""selected""";
				}
				else
				{
					pop3Selected = "";
				}
				if (defaultIncProtocol == IMAP4_PROTOCOL)
				{
					imap4Selected = @" selected=""selected""";
				}
				else
				{
					imap4Selected = "";
				}
				if (defaultIncProtocol == WMSERVER_PROTOCOL)
				{
					wmserverSelected = @" selected=""selected""";
				}
				else
				{
					wmserverSelected = "";
				}

				if (defaultUseSmtpAuth == true)
				{
					smtpAuthChecked = @" checked=""checked""";
				}
				else
				{
					smtpAuthChecked = "";
				}

				if (defaultSignMe == true)
				{
					signMeChecked = @" checked=""checked""";
				}
				else
				{
					signMeChecked = "";
				}

				//for version without ajax
				errorClass = "wm_hide"; //if there is no error
				errorDesc = "";
				mode = Request["mode"]; //mode = standard|advanced|submit
				switch (mode)
				{
					case "advanced":
						DisplayAdvancedMode();
						break;
					case "submit":
						DisplayStandardMode();
						globalEmail = Request["email"];
						globalLogin = Request["login"];
						globalPassword = Request["password"];
						globalIncServer = Request["inc_server"];
						globalIncProtocol = Request["inc_protocol"];
						globalIncPort = Request["inc_port"];
						globalOutServer = Request["out_server"];
						globalOutPort = Request["out_port"];
						globalUseSmtpAuth = Request["smtp_auth"];
						globalSignMe = Request["sign_me"];
						globalAdvancedLogin = Utils.EncodeJsSaveString(Request["advanced_login"]);//0|1

                        if (globalAdvancedLogin == "0")
                        {
                            switch (settings.HideLoginMode)
                            {
                                case LoginMode.HideLoginFieldLoginIsAccount:
                                    globalLogin = EmailAddress.Parse(globalEmail).GetAccountName();
                                    break;
                                case LoginMode.HideLoginFieldLoginIsEmail:
                                    globalLogin = globalEmail;
                                    break;
                                case LoginMode.HideEmailField:
                                case LoginMode.HideEmailFieldDisplayDomainAfterLogin:
                                    globalEmail = string.Format("{0}@{1}", globalLogin, defaultDomainOptional);
                                    break;
                                case LoginMode.HideEmailFieldLoginIsLoginAndDomain:
                                case LoginMode.HideEmailFieldDisplayDomainAfterLoginAndLoginIsLoginAndDomain:
                                    globalEmail = string.Format("{0}@{1}", globalLogin, defaultDomainOptional);
                                    globalLogin = globalEmail;
                                    break;
                            }
                        }

                        if (!Validation.CheckIt(Validation.ValidationTask.Email, globalEmail))
						{
							errorDesc = _resMan.GetString(Validation.ErrorMessage);
							errorClass = "wm_login_error";
							break;
						}
						else
						{
							globalEmail = Validation.Corrected;
						}
						if (!Validation.CheckIt(Validation.ValidationTask.Login, globalLogin))
						{
							errorDesc = _resMan.GetString(Validation.ErrorMessage);
							errorClass = "wm_login_error";
							break;
						}
						else
						{
							globalLogin = Validation.Corrected;
						}
						if (!Validation.CheckIt(Validation.ValidationTask.Password, globalPassword))
						{
							errorDesc = _resMan.GetString(Validation.ErrorMessage);
							errorClass = "wm_login_error";
							break;
						}
						if (!Validation.CheckIt(Validation.ValidationTask.INServer, globalIncServer, globalAdvancedLogin))
						{
							errorDesc = _resMan.GetString(Validation.ErrorMessage);
							errorClass = "wm_login_error";
							break;
						}
						else
						{
							globalIncServer = Validation.Corrected;
						}
						if (!Validation.CheckIt(Validation.ValidationTask.INPort, globalIncPort, globalAdvancedLogin))
						{
							errorDesc = _resMan.GetString(Validation.ErrorMessage);
							errorClass = "wm_login_error";
							break;
						}
						else
						{
							globalIncPort = Validation.Corrected;
						}
						if (!Validation.CheckIt(Validation.ValidationTask.OUTServer, globalOutServer, globalAdvancedLogin))
						{
							errorDesc = _resMan.GetString(Validation.ErrorMessage);
							errorClass = "wm_login_error";
							break;
						}
						else
						{
							globalOutServer = Validation.Corrected;
						}
						if (!Validation.CheckIt(Validation.ValidationTask.OUTPort, globalOutPort, globalAdvancedLogin))
						{
							errorDesc = _resMan.GetString(Validation.ErrorMessage);
							errorClass = "wm_login_error";
							break;
						}
						else
						{
							globalOutPort = Validation.Corrected;
						}

						try
						{
							Account acct = Account.LoginAccount(globalEmail, globalLogin, globalPassword, globalIncServer, Convert.ToInt32(globalIncPort), globalOutServer, Convert.ToInt32(globalOutPort), ((string.Compare(globalUseSmtpAuth, "1", true, CultureInfo.InvariantCulture) == 0) ? true : false), (string.Compare(globalAdvancedLogin, "1", true, CultureInfo.InvariantCulture) == 0) ? true : false);
							
							if(acct != null)
							{
								Session.Add(Constants.sessionAccount, acct);
								Response.Redirect("basewebmail.aspx", false);
							}
						}
						catch(Exception message)
						{
							Log.WriteLine("Page_Load", "Login Account");
							Log.WriteException(message);
							errorDesc = message.Message;
							errorClass = "wm_login_error"; //if the error was occured
						}
						break;
					default:
						DisplayStandardMode();
						break;
				}
				//end for version without ajax

				string error = Request["error"];
				if (error == null) error = string.Empty;
				if (error == "1") 
				{
					errorDesc = "The previous session was terminated due to a timeout.";
					errorClass = "wm_login_error"; //if the error was occured
				} 
			}
			catch (Exception ex)
			{
				Log.WriteException(ex);
				throw;
			}
		}

		protected void DisplayStandardMode()
		{
			switcherHref = "?mode=advanced";
			switcherText = _resMan.GetString("AdvancedLogin");
			advancedDisplay = @"none";
			advancedLogin = "0";
			if (settings.HideLoginMode == LoginMode.HideEmailField ||
				settings.HideLoginMode == LoginMode.HideEmailFieldDisplayDomainAfterLogin ||
				settings.HideLoginMode == LoginMode.HideEmailFieldDisplayDomainAfterLoginAndLoginIsLoginAndDomain ||
				settings.HideLoginMode == LoginMode.HideEmailFieldLoginIsLoginAndDomain)
			{
				emailClass = @" class=""wm_hide""";
			}
			if (settings.HideLoginMode == LoginMode.HideLoginFieldLoginIsAccount ||
				settings.HideLoginMode == LoginMode.HideLoginFieldLoginIsEmail)
			{
				loginClass = @" class=""wm_hide""";
			}
			if (settings.HideLoginMode == LoginMode.HideEmailFieldDisplayDomainAfterLogin ||
				settings.HideLoginMode == LoginMode.HideEmailFieldDisplayDomainAfterLoginAndLoginIsLoginAndDomain)
			{
				loginWidth = "150px";
				domainContent = "&nbsp;@" + defaultDomainOptional;
			}
		}

		protected void DisplayAdvancedMode()
		{
			switcherHref = "?mode=standard";
			switcherText = _resMan.GetString("StandardLogin");
			advancedDisplay = "block";
			advancedLogin = "1";
			emailClass = "";
			loginClass = "";
			loginWidth = "99%";
			domainContent = "";
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
